#include "spettro.h"
#include <iostream.h>

//creatore
Spettro::Spettro()
	{
		nCoppie=0;
		primo=new Coppia;
		ultimo=primo;
	}

//creatore di coppia
Spettro::Spettro(const Spettro& cc)
	{
		nCoppie=0;
		primo=new Coppia;
		ultimo=primo;
		for (corrente=cc.primo;corrente!=cc.ultimo;corrente=Shift(corrente))
		  XY(corrente->x,corrente->y);
	}

//distruttore
Spettro::~Spettro()
	{
			for (corrente=primo;corrente!=ultimo;corrente=temp)
				{
				 temp=Shift(corrente);
				 delete corrente;
				}
	}

void Spettro::Svuota()
	{
			for (corrente=primo;corrente!=ultimo;corrente=temp)
				{
				 temp=Shift(corrente);
				 delete corrente;
				}
			nCoppie=0;
			primo=new Coppia;
			ultimo=primo;
	}

PuntaCoppia  Spettro::AggiungiCoppia(float a,float b,PuntaCoppia pcp)
	{
	  nCoppie++;
	  pcp->x=a;
	  pcp->y=b;
	  pcp->puntcp=new (Coppia);
	  return pcp->puntcp;
	}

int Spettro::XY(float a, float b)
	{
	  ultimo=AggiungiCoppia(a,b,ultimo);
	  return nCoppie;
	}

int Spettro::NumCoppie()
	{
	  return nCoppie;
	}

float Spettro::Massimo()
	{
		float max=primo->y;
		for (corrente=primo;corrente!=ultimo;corrente=Shift(corrente))
			if (corrente->y>max)
				max=corrente->y;
		return max;
	 }

float Spettro::Minimo()
	{
		float min=primo->y;
		for (corrente=primo;corrente!=ultimo;corrente=Shift(corrente))
			if (corrente->y<min)
				min=corrente->y;
		return min;
	 }

float Spettro::Xmi()
	{
		float min=primo->x;
		for (corrente=primo;corrente!=ultimo;corrente=Shift(corrente))
			if (corrente->x<min)
				min=corrente->x;
		return min;
	 }

float Spettro::Xma()
	{
		float max=primo->x;
		for (corrente=primo;corrente!=ultimo;corrente=Shift(corrente))
			if (corrente->x>max)
				max=corrente->x;
		return max;
	 }


float Spettro::TrovaX(int j)
	 {
		if (j>nCoppie)
			  return 0;
		else
			{
			  corrente=primo;
			  for (int i=1;i<j;i++)
				 corrente=Shift(corrente);
			  return corrente->x;
			}
	  }

float Spettro::TrovaY(int j)
	 {
		if (j>nCoppie)
			  return 0;
		else
			{
			  corrente=primo;
			  for (int i=1;i<j;i++)
				 corrente=Shift(corrente);
			  return corrente->y;
			}
	  }

void Spettro::CambiaXY(int j,float a,float b)
	{
		if (j>nCoppie)
			  return;
		else
			{
			  corrente=primo;
			  for (int i=1;i<j;i++)
				 corrente=Shift(corrente);
			  corrente->x=a;
			  corrente->y=b;
			}
	}

Spettro Spettro::operator *(float m)
{
		Spettro nuovo;
		for (PuntaCoppia corrente=primo;corrente!=ultimo;
					corrente=Shift(corrente))
						nuovo.XY(corrente->x,m*corrente->y);
		return nuovo;
}


Spettro& Spettro::operator =(const Spettro &sp)
{
	Svuota();
	PuntaCoppia pc;
	for (pc=sp.primo;pc!=sp.ultimo;pc=Shift(pc)) XY(pc->x,pc->y);
	return *this;
}

void Spettro::Invert()
{
	float *x,*y;
	int i=0,ntmp=nCoppie;
	x=new float[ntmp];
	y=new float[ntmp];
	PuntaCoppia pc;
	for (pc=primo;pc!=ultimo;pc=Shift(pc)) {x[i]=pc->x;y[i++]=pc->y;}
	Svuota();
	for (i=ntmp-1;i>0;i--) XY(x[i],y[i]);
	delete [] x;
	delete [] y;
}

